   import java.awt.Frame;
   import java.awt.Insets;

    public class BoundedBall extends MovableBall
   {
      private Frame myWorld;
   
       public BoundedBall( int x, int y, int r,
                       double dx, double dy, Frame aWorld )
      {
         super( x, y, r, dx, dy );
         myWorld = aWorld;
      }
   
       public void move()
      {
         super.move();
      
         Insets worldInsets = myWorld.getInsets();
         int maxHeight = myWorld.getHeight();
         int maxWidth  = myWorld.getWidth();
      
         if ( (x()-radius() < worldInsets.left) 
         || (x()+radius() > maxWidth-worldInsets.right) ) {
            setMotion( -xMotion(), yMotion() );
         }	// end if
			
         if ( (y()-radius() < worldInsets.top) 
         || (y()+radius() > maxHeight - worldInsets.bottom) )
            setMotion( xMotion(), -yMotion() );
      }
   }
