//
// FILE:     DeceleratingBall.java
// AUTHOR:   Eugene Wallingford
// DATE:     03/10/99
// COMMENT:  Created to demonstrate the Decorator pattern.
//

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

public class DeceleratingBall extends MovableBall 
{
   private MovableBall workerBall;

   public DeceleratingBall( MovableBall aBall )
   {
      super();
      workerBall = aBall;
   }

   public void move()
   {
      workerBall.move();
      workerBall.setMotion( workerBall.xMotion() * 0.95,
                            workerBall.yMotion() * 0.95 );
   }

   // *** MESSAGES DELEGATED TO THE INSTANCE VARIABLE

   public void paint( Graphics g )
   {
      workerBall.paint( g );
   }

   public void setColor( Color newColor )
   {
      workerBall.setColor( newColor );
   }

   public Color color()
   {
      return workerBall.color();
   }

   protected int radius() { return workerBall.radius(); }

   protected int x() { return workerBall.x(); }
   protected int y() { return workerBall.y(); }

   protected Rectangle region() { return workerBall.region(); }

   protected void moveTo( int x, int y )
   {
      workerBall.moveTo( x, y );
   }

   protected void setMotion( double ndx, double ndy )
   {
      workerBall.setMotion( ndx, ndy );
   }

   protected double xMotion ()
   {
      return workerBall.xMotion();
   }

   protected double yMotion ()
   {
      return workerBall.yMotion();
   }
}
